module Rammed
  module Monad
    COMMON_FUNCS = {
      bind: Rammed.invoker(1, :bind),
      ap: Rammed.invoker(1, :ap),
      map: Rammed.invoker(1, :map)
    }.freeze
    module Base
      def >>(f)
        bind(f)
      end

      def <(other)
        ap(other)
      end

      def >(other)
        other.ap(self)
      end

      def ap(other)
        self >> (lambda do |f|
          other >> (lambda do |x|
            mreturn f.(x)
          end)
        end)
      end

      def map(f)
        self >> ->(x) { mreturn f.(x) }
      end
    end
  end
end
