require 'ostruct'

module Rammed
  module_function

  def adjust(f, i, l)
    new_list = l.clone
    new_list[i] = f.(l[i])
    new_list.freeze
  end

  def curry_n(n, f)
    f.curry(n)
  end

  def invoker(n, sym, block=-1)
    curry_n(n + 1, (lambda do |*args|
      block_removed_args = block >= 0 ? args.slice(0...block) + args.slice(block + 1..-1) : args
      actual_args = block_removed_args.slice(0...-1)
      obj = args.last
      block_arg = args[block] if block >= 0
      if block_arg
        obj.send(sym, *(actual_args), &block_arg)
      else
        obj.send(sym, *(actual_args))
      end
    end))
  end
  Core = OpenStruct.new(
    identity: ->(x) { x },
    const: ->(x) { ->(*_) { x } },
    compose: ->(f, g) { ->(*args) { f.(g.(*args)) } },
    compose_all: ->(*args) { args.reduce(identity, &compose) },
    partial: ->(f, *args) { ->(*in_args) { f.(*(args + in_args)) } },
    partial_right: ->(f, *args) { ->(*in_args) { f.(*(in_args + args)) } },
    partial_block: ->(f, b) { ->(*args) { f.(*args, &b) } },
    curry: (lambda do |f|
      throw 'Variadic and nullary functions may not be curried.' if f.arity <= 0
      f.curry
    end),
    curry_n: Rammed.method(:curry_n),
    invoker: Rammed.method(:invoker),
    add: curry_n(2, ->(a, b) { a + b }),
    adjust: Rammed.method(:adjust).curry(3),
    all: Rammed.invoker(1, :all?, 0),
    compose_k: ->(f, g) { ->(*args) { g.(*args) >> f } }
  )
end
